/*
 
  copyright (c) 2004, Michal Salaban <emes@pld-linux.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2 as
  published by the Free Software Foundation (see file COPYING for details).

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
*/

/* $Id: mainloop.c,v 1.2 2004/02/08 18:26:02 emes Exp $ */

#include <stdio.h>
#include "parseopt/lex.h"
#include "conditions.h"
#include "getstats.h"

ruleset     **ruletab;
int         step = 10;

void main_loop ()
{
    ruleset     *rule;
    int         cur;

    while (1) {
        fetch_la ();
        fetch_mem ();

        cur = 0;
        while (*(ruletab + cur) != NULL) {
            rule = *(ruletab + cur);

            /* save result of this and previous hit */
            rule->prevhit = rule->hit;
            rule->hit = check_expression (rule->expr);

            if (rule->hit) {
#ifdef DEBUG
                printf ("Rule %d hit.\n", cur);
#endif
                if (rule->run != NULL)
                    if (! (rule->run->once && rule->prevhit)) {
                        system (rule->run->runcmd);
#ifdef DEBUG
                        printf ("executed '%s'\n", rule->run->runcmd);
#endif
                    }
                if (rule->log != NULL)
                    if (! (rule->log->once && rule->prevhit)) {
                        /** talk to log **/
#ifdef DEBUG
                        printf ("rule logged\n");
#endif
                    }
            } else {
#ifdef DEBUG                
                printf ("Rule %d NOT hit.\n", cur);
#endif
            }
            cur++;
        }

        sleep (step);            
    }
}


/* $Id: mainloop.c,v 1.2 2004/02/08 18:26:02 emes Exp $ */
